//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "UDelThread.h"
#include "UIndicatorProcess.h"
#include "Unit1.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TDelThread::TDelThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
 FreeOnTerminate=1;
 lst=new TStringList;
 delFileDir=ExtractFilePath(Application->ExeName)+"deleteFile\\";
}
//---------------------------------------------------------------------------
void __fastcall TDelThread::Execute()
{
 Synchronize(LabMess1);
 viewDirs(directory);
 FormHideCreatePross->ProgressBar1->Max=lst->Count-1;
 for(int i=0; i<lst->Count && !Terminated; i++)
 {
   dfile=lst->Strings[i];
   int fAttr=(int)lst->Objects[i];
   String sub=dfile,
          newfile=delFileDir+sub.Delete(1,ExtractFilePath(directory).Length());
   if(fAttr & faDirectory)
   {
     ForceDirectories(newfile);
     FileSetAttr(dfile,faDirectory);
     RemoveDir(dfile);
   }
   else
   {
     ForceDirectories(ExtractFileDir(newfile));
     if(FileExists(newfile))DeleteFile(newfile);
     MoveFile(dfile.c_str(),newfile.c_str());
   }
   Synchronize(refreshDel);
 }
 delete lst;
 FormHideCreatePross->Close();
}
//---------------------------------------------------------------------------
void TDelThread::viewDirs(String dir)
{
 TSearchRec sr;
 String path=IncludeTrailingPathDelimiter(dir),
        mask=path+"*.*";
 if(!FindFirst(mask,faAnyFile,sr))
   do
   {
     if(sr.Name=="." || sr.Name=="..")continue;
     dfile=path+sr.Name;
     if(sr.Attr & faDirectory)
     {
       viewDirs(dfile);
     }
     else
       lst->AddObject(dfile,(TObject*)sr.Attr);
   }while(!FindNext(sr) && !Terminated);
 lst->AddObject(dir,(TObject*)faDirectory);
 FindClose(sr);
}
//---------------------------------------------------------------------------
void __fastcall TDelThread::LabMess1()
{
 FormHideCreatePross->Label1->Caption=" ";
}
//---------------------------------------------------------------------------
void __fastcall TDelThread::refreshDel()
{
 String sub=dfile.SubString(dfile.LastDelimiter("\\")+1,MAX_PATH);
 FormHideCreatePross->Label2->Caption=sub;
 FormHideCreatePross->Label1->Caption=" ";
 FormHideCreatePross->ProgressBar1->StepIt();
}
//---------------------------------------------------------------------------

